include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"

ext charOffset_, dotOffset_, Ground_, VVram_
ext TerrainPattern_

TerrainPatternRam0 equ CharPatternRam+CharSize*Char_Terrain0
TerrainPatternRam1 equ CharPatternRam+CharSize*Char_Terrain1

TileSize equ 4
GroundHeight equ VVramHeight+TileSize
Char_Count equ Char_Terrain1-Char_Terrain0

pSource equ ZW0
pDestination equ ZW1
yCount equ ZB0

GroundBottom equ Ground_+VVramWidth*(GroundHeight-1)

; void RollDown();
cseg
RollDown_: public RollDown_
    pha
        lda #low GroundBottom | sta <pDestination
        lda #high GroundBottom | sta <pDestination+1
        lda #GroundHeight-1 | sta <yCount
        do
            lda <pDestination | sec|sbc #VVramWidth | sta <pSource
            lda <pDestination+1 | sbc #0 | sta <pSource+1
            ldy #VVramWidth
            do
                dey
                lda (<pSource),y
                sta (<pDestination),y
                cpy #0
            while ne | wend
            lda <pSource | sta <pDestination
            lda <pSource+1 | sta <pDestination+1
            dec <yCount
        while ne | wend
    pla
rts


; void RollChar();
cseg
RollChar_: public RollChar_
    pha
        lda charOffset_
        if eq
            lda #low TerrainPatternRam0 | sta <pDestination
            lda #high TerrainPatternRam0 | sta <pDestination+1
        else
            lda #low TerrainPatternRam1 | sta <pDestination
            lda #high TerrainPatternRam1 | sta <pDestination+1
        endif
        lda #7 | sec|sbc dotOffset_
        asl a | asl a
        clc|adc #low TerrainPattern_ | sta <pSource
        lda #high TerrainPattern_ | adc #0 | sta <pSource+1

        ldx #Char_Count
        do
            sei
                defb $03,$00 ; st0
                lda <pDestination | sta >$0002
                lda <pDestination+1 | sta >$0003
                ldy #0
                do
                    defb $03,$02 ; st0
                    lda (<pSource),y | iny
                    sta >$0002
                    lda (<pSource),y | iny
                    sta >$0003
                    iny | iny
                    cpy #CharHeight*4
                while ne | wend
                ldy #2
                do
                    defb $03,$02 ; st0
                    lda (<pSource),y | iny
                    sta >$0002
                    lda (<pSource),y | iny
                    sta >$0003
                    iny | iny
                    cpy #CharHeight*4+2
                while ne | wend
            cli
            lda <pSource | clc|adc #(15*4) | sta <pSource
            lda <pSource+1 | adc #0 | sta >pSource+1

            lda <pDestination | clc|adc #CharSize | sta <pDestination
            lda <pDestination+1 | adc #0 | sta >pDestination+1
            
            dex
        while ne | wend
    pla
rts
