include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"

ext VVram_, RowFlags_
ext charOffset_, dotOffset_, Ground_
ext Status_

pSource equ ZW0
pDestination equ ZW1

; word VVramOffset(byte x, byte y)
dseg
VVramOffset_@Param0: public	VVramOffset_@Param0
VVramOffset_.x_:	defs 1
VVramOffset_@Param1: public	VVramOffset_@Param1
VVramOffset_.y_:	defs 1
cseg
VVramOffset_: public	VVramOffset_
	pha
        lda	VVramOffset_.y_
        asl a | asl a | asl a  ;*8
        sta <pDestination | lda #0 | sta <pDestination+1
        asl <pDestination | rol <pDestination+1 ;16
        asl <pDestination | rol <pDestination+1 ;32
        lda VVramOffset_.x_ | clc | adc <pDestination | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1
        ldy <pDestination | ldx <pDestination+1
	pla
rts


; void GroundToVVram();
cseg
GroundToVVram_: public GroundToVVram_
    pha
        lda #low(Ground_+VVramWidth*4) | sta <pSource
        lda #high(Ground_+VVramWidth*4) | sta <pSource+1

        lda #low VVram_ | sta <pDestination
        lda #high VVram_ | sta <pDestination+1

        ldx #VVramHeight
        do
            ldy #0
            do
                lda (<pSource),y
                clc|adc charOffset_
                sta (<pDestination),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pSource | clc|adc #VVramWidth | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #VVramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dex
        while ne | wend
    pla
rts


; void StatusToVVram();
cseg
StatusToVVram_: public StatusToVVram_
    pha
        lda #low Status_ | sta <pSource
        lda #high Status_ | sta <pSource+1

        lda #low VVram_ | sta <pDestination
        lda #high VVram_ | sta <pDestination+1

        ldx #StatusHeight
        do
            ldy #0
            do
                lda (<pSource),y
                if ne
                    sta (<pDestination),y
                endif
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pSource | clc|adc #VVramWidth | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #VVramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dex
        while ne | wend
    pla
rts
